(********************************************************************
 * PROGRAM: restore
 * File: Lika.st
 * Created: August 04, 2015
 ********************************************************************
 * Implementation of program Lika
 ********************************************************************)

PROGRAM _CYCLIC

	IF GlobalError=1 THEN 
		RETURN;
	END_IF
	
	IF Write_bit_restore=0 THEN
		RETURN;  
	END_IF	
	
	CASE epl.state OF 	
	
		EPL_WAIT:  (*state to wait for user Commands*)
			epl.state := EPL_WRITE_OE;   
		EPL_WRITE_OE:  
			IF bit_restore=TRUE THEN
				OperatingParameter:=OperatingParameter OR 16#4000;
			END_IF
			IF bit_restore=FALSE THEN
				OperatingParameter:=OperatingParameter AND 16#7fff;
			END_IF
			//==================== WRITE OBJECT ENTRY ========================
			epl.fub.EplSDOWrite_0.enable := 1;  (*enable the FUB*)
			epl.fub.EplSDOWrite_0.pDevice := ADR('IF3');  (*Device Name of Powerlink interface*)
			epl.fub.EplSDOWrite_0.node := 2;  (*Node Number of the Station to be read*)
			epl.fub.EplSDOWrite_0.index := 16#6000;  (*Write index *)
			epl.fub.EplSDOWrite_0.subindex := 0;  (*Subindex *)
			epl.fub.EplSDOWrite_0.pData:=ADR(OperatingParameter);(*pointer to the variable to be read*)
			epl.fub.EplSDOWrite_0.datalen:=SIZEOF(OperatingParameter);(*Length of the Data to be read*)
			
			IF epl.fub.EplSDOWrite_0.status = 0 THEN  
				(*writing successful*)	
				Write_bit_restore:=0;
				epl.state := EPL_WAIT;
				epl.fub.EplSDOWrite_0.enable := 0;  (*disable the FUB*)	
			ELSIF epl.fub.EplSDOWrite_0.status = ERR_FUB_BUSY THEN  
				(*Busy*)
			ELSIF epl.fub.EplSDOWrite_0.status = ERR_FUB_ENABLE_FALSE THEN  
				(*FUB is disabled*)
			ELSE  (*Go to error Step*)
				epl.state := EPL_ERROR;				
			END_IF
		EPL_ERROR:  
			(* Here some error Handling has to be implemented *)
			GlobalError:=1;
	END_CASE;	
	
	epl.fub.EplSDOWrite_0();  (*Call the EplSDOWrite_0 FUB*)

END_PROGRAM
